/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.test;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import kinugasa.contents.graphics.ImageUtil;
import kinugasa.contents.sound.LoopPoint;
import kinugasa.contents.sound.SoundBuilder;
import kinugasa.game.GameConfig;
import kinugasa.game.KinugasaGame;
import kinugasa.game.PlayerConstants;

/**
 * .
 * <br>
 *
 * <br>
 * @version 1.0.0 - 2013/04/21_11:41:02<br>
 * @author Dra0211<br>
 */
public class MyGame extends KinugasaGame {

	public static void main(String[] args) {
		new MyGame().gameStart();
	}

	private MyGame() {
		super("");
	}

	@Override
	protected void startUp() {
		new SoundBuilder(PlayerConstants.getInstance().DESKTOP_PATH + "/field3.wav").setLoopPoint(LoopPoint.END_TO_START).builde().load().play();
		
	}

	@Override
	protected void dispose() {
	}

	@Override
	protected void update() {
		getWindow().setTitle(getGameTimeManager().getFPSStr());
	}

	@Override
	protected void draw(Graphics2D g) {
	}
}
